############################################################################
# Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2011. #
# All Rights Reserved.                                                     #
#                                                                          #
# Pre-requisite: WAS and CLM should be installed. Cluster should exist     #
# This script installs the list of CLM apps to all the app servers in a    #
# cluster                                                                  #
#                                                                          #
# Usage (Win):                                                             #
#    wsadmin -language jython -user <username> -password <password>        #  
#    -f <path to clm_deploy_cluster_distributed.py e.g.                    #
#    C:/JazzTeamServer/server/was/clm_deploy_cluster_distributed.py>       #
#    <nodename of node running the deployment manager> <clustername>       #
#    <path to war files e.g.                                               #
#    C:/JazzTeamServer/server/webapps/>                                    #
#    <comma-separated list (no spaces) of apps to be deployed e.g. jts,ccm>#
# Usage (Linux):                                                           #
#    ./wsadmin.sh -language jython -user <username> -password <password>   #
#    -f <path to clm_deploy_cluster_distributed.py e.g.                    #
#    /opt/IBM/JazzTeamServer/server/was/clm_deploy_cluster_distributed.py> #
#    <nodename of node running the deployment manager> <clustername>       #
#    <path to war files e.g.                                               #
#    /opt/IBM/JazzTeamServer/server/webapps/>                              #
#    <comma-separated list (no spaces) of apps to be deployed e.g. jts,ccm>#
############################################################################

# Get the node from commandline
node = sys.argv[2]
# Get the server name from commandline
server = sys.argv[3]
# Get the location of the war files
war_location = sys.argv[4]

# list of CLM apps to be deployed
apps=sys.argv[5]
apps=apps [0:len(apps)].split(",")

#######################
# deploy all the apps #
#######################

try:
	_excp_ = 0
	for app in apps:
		attrs = ['-appname', app+".war", '-defaultbinding.virtual.host default_host -usedefaultbindings', '-node', node, '-cluster', server, '-contextroot',  "/"+app]
		print "Installing "+app
		error = AdminApp.install(war_location + app + ".war", attrs)
		AdminConfig.save()
	#endFor
	print "The installed application(s) may be started from the Integrated Solutions Console in WebSphere."
except:
	_type_, _value_, _tbck_ = sys.exc_info()
	error = `_value_`
	_excp_ = 1
#endTry 
if (_excp_ ):
	print "Error Installing Application "
	print "Error Message = "+error
#endIf

# Example of how to set role/mapping for jts.war
# AdminApp.edit('jts.war', '[-MapRolesToUsers [["JazzAdmins" No No "" admins]["JazzDWAdmins" No No "" admins]["JazzUsers" No No "" users]["JazzGuests" No No "" users]["JazzProjectAdmins" No No "" admins]]]')
# AdminConfig.save() 